package main

import (
	"fmt"
	"go.uber.org/zap"
	"reader/internal/config"
	"reader/internal/unpacker"
	"time"

	log2 "git.insit.tech/sas/rtsp_proxy/core/log"
	logger "reader/internal/log"
)

func main() {
	//port := 8080
	//
	//http.HandleFunc("GET /download", handlers.Download) // example request: {"date": "07-03-2025", "start_time": "16-43", "end_time": "16-44"}
	//http.HandleFunc("GET /hls/", handlers.HLS)
	//
	//log.Println("Starting server on:")
	//log.Printf("Serving on HTTP port: %d\n", port)
	//
	//log.Fatal(http.ListenAndServe(fmt.Sprintf(":%d", port), nil))

	config.LogsDirectory = log2.DirCreator(config.Local, "logs")
	logger.Log = log2.MainLogging(
		fmt.Sprintf("%s/reader-main_%s.log", config.LogsDirectory, time.Now().Format("15-04-05_02-01-2006")))

	err := unpacker.CreateVideo(config.Local)
	if err != nil {
		logger.Log.Error("Failed to create flow", zap.Error(err))
	}
}
